diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
index 4488db962..89fdb342f 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
@@ -6,9 +6,11 @@ import net.minecraft.core.entity.MobFlying;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.entity.projectile.ProjectileFireball;
 import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.vehicle.EntityBoat;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.util.helper.LightIndexHelper;
 import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.world.pos.TilePos;
@@ -209,6 +211,16 @@ public class MobGhast extends MobFlying
         }
     }
 
+    @Override
+    public boolean canBreatheUnderwater() {
+        return true;
+    }
+
+    @Override
+    public boolean hurtByNetherWater() {
+        return false;
+    }
+
     @Override
     public String getLivingSound() {
         return "mob.ghast.moan";
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombiePig.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombiePig.java
index 297204471..80250b69e 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombiePig.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombiePig.java
@@ -163,4 +163,14 @@ public class MobZombiePig extends MobZombie {
 
         return drops;
     }
+
+    @Override
+    public boolean canBreatheUnderwater() {
+        return true;
+    }
+
+    @Override
+    public boolean hurtByNetherWater() {
+        return false;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemCrystalBud.java b/game/core/src/main/java/net/minecraft/core/item/ItemCrystalBud.java
new file mode 100644
index 000000000..f68293d96
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemCrystalBud.java
@@ -0,0 +1,54 @@
+package net.minecraft.core.item;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogicFarmland;
+import net.minecraft.core.block.BlockLogicRotatable;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.entity.TileEntityActivator;
+import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.enums.EnumBlockSoundEffectType;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Random;
+
+public class ItemCrystalBud extends Item {
+
+    public ItemCrystalBud(@NotNull String name, @NotNull String namespaceId, int id) {
+        super(name, namespaceId, id);
+    }
+
+    @Override
+    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
+        if (!world.canPlaceInsideBlock(blockPos)) {
+            blockPos = blockPos.add(side.getDirection(), new TilePos());
+        }
+
+        TilePos queryPos = new TilePos();
+
+        if (world.getBlockType(blockPos.down(queryPos)).hasTag(BlockTags.GROWS_RUBYGLASS)) {
+            if (world.setBlockType(blockPos, Blocks.RUBYGLASS_BUD)) {
+                world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, Blocks.RUBYGLASS_BUD, EnumBlockSoundEffectType.PLACE);
+                selfStack.consumeItem(player);
+                return true;
+            }
+        }
+        return false;
+    }
+
+    @Override
+    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
+        blockPos = blockPos.add(direction, new TilePos());
+        Block<?> b = world.getBlockType(blockPos);
+        boolean canGrowRubyglass = world.getBlockType(blockPos).hasTag(BlockTags.GROWS_RUBYGLASS);
+        if (b == null || canGrowRubyglass || BlockTags.PLACE_OVERWRITES.appliesTo(b)) {
+            onUseOnBlock(selfStack, world, null, blockPos.add(0, canGrowRubyglass ? 1 : 0, 0, new TilePos()), direction.getSide(), 0.5, 0.5);
+        }
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/item/Items.java b/game/core/src/main/java/net/minecraft/core/item/Items.java
index 3a1e03ea1..c01f9a317 100644
--- a/game/core/src/main/java/net/minecraft/core/item/Items.java
+++ b/game/core/src/main/java/net/minecraft/core/item/Items.java
@@ -205,6 +205,9 @@ public final class Items {
     public static Item SIGN_PAINTED;
     public static Item DOUGH;
     public static Item WAND_NBT;
+    public static Item RUBYGLASS_CRYSTAL_CRACKED;
+    public static Item RUBYGLASS_CRYSTAL_PURE;
+
 
     private static boolean hasInit = false;
     public static void init(){
@@ -430,5 +433,7 @@ public final class Items {
         FOOD_VENISON_COOKED = (new ItemFood("food.venison.cooked", "minecraft:item/food_venison_cooked", 16551, 12, 8, true, 4));
         DOUGH = (new Item("dough", "minecraft:item/dough", 16552));
         WAND_NBT = new ItemWandNBT("wand.nbt", "minecraft:item/wand_nbt", 16553);
+        RUBYGLASS_CRYSTAL_CRACKED = (new ItemCrystalBud("rubyglass.crystal.cracked", "minecraft:item/rubyglass_crystal_cracked", 16554));
+        RUBYGLASS_CRYSTAL_PURE = (new ItemCrystalBud("rubyglass.crystal.pure", "minecraft:item/rubyglass_crystal_pure", 16555));
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/Biomes.java b/game/core/src/main/java/net/minecraft/core/world/biome/Biomes.java
index e42bbc5d1..81198680a 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/Biomes.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/Biomes.java
@@ -33,12 +33,14 @@ public class Biomes
     public static final Biome OVERWORLD_OUTBACK_GRASSY = register("minecraft:overworld.outback.grassy", new BiomeOutback("overworld.outback.grassy").setColor(0xf09037).setBlockedWeathers(Weathers.OVERWORLD_SNOW).setTopBlock(Blocks.GRASS_SCORCHED.id()).setFillerBlock(Blocks.DIRT_SCORCHED.id()).setDefaults(0.825f, 0.1f, 1.0f));
     public static final Biome OVERWORLD_CAATINGA = register("minecraft:overworld.caatinga", new BiomeCaatinga("overworld.caatinga").setColor(0xdecda6).setTopBlock(Blocks.MUD_BAKED.id()).setFillerBlock(Blocks.MUD_BAKED.id()).setBlockedWeathers(Weathers.OVERWORLD_SNOW).setDefaults(0.95f, 0.015f, 0.5f));
     public static final Biome OVERWORLD_CAATINGA_PLAINS = register("minecraft:overworld.caatinga.plains", new Biome("overworld.caatinga.plains").setColor(0xa19477).setTopBlock(Blocks.MUD_BAKED.id()).setFillerBlock(Blocks.MUD_BAKED.id()).setBlockedWeathers(Weathers.OVERWORLD_SNOW).setDefaults(0.95f, 0.015f, 0.0f));
-    public static final Biome NETHER_NETHER = register("minecraft:nether.nether", new BiomeNether("nether.nether").setColor(0xDD0000).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG).setTopBlock(Blocks.COBBLE_NETHERRACK.id()).setFillerBlock(Blocks.COBBLE_NETHERRACK.id()));
-    public static final Biome NETHER_VOLCANIC_ISLANDS = register("minecraft:nether.volcanic_islands", new BiomeVolcanoIslands("nether.volcanic_islands").setColor(0xDD0000).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG).setTopBlock(Blocks.COBBLE_NETHERRACK.id()).setFillerBlock(Blocks.COBBLE_NETHERRACK.id()));
-    public static final Biome NETHER_SULFUR_POOLS = register("minecraft:nether.sulfur_pools", new BiomeSulfurPools("nether.sulfur_pools").setColor(0xDD0000).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG).setTopBlock(Blocks.COBBLE_NETHERRACK.id()).setFillerBlock(Blocks.COBBLE_NETHERRACK.id()));
+
+    public static final Biome NETHER_CRAG = register("minecraft:nether.crag", new BiomeNether("nether.crag").setColor(0x633e3d).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG).setTopBlock(Blocks.COBBLE_NETHERRACK.id()).setFillerBlock(Blocks.COBBLE_NETHERRACK.id()));
+    public static final Biome NETHER_VOLCANIC_ISLANDS = register("minecraft:nether.volcanic_islands", new BiomeVolcanoIslands("nether.volcanic_islands").setColor(0xffa333).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG).setTopBlock(Blocks.BRIMSAND.id()).setFillerBlock(Blocks.BRIMSAND.id()));
+    public static final Biome NETHER_SULFUR_POOLS = register("minecraft:nether.sulfur_pools", new BiomeSulfurPools("nether.sulfur_pools").setColor(0xa39940).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG).setTopBlock(Blocks.BRIMSAND.id()).setFillerBlock(Blocks.BRIMSAND.id()));
+    public static final Biome NETHER_CRYSTAL_FIELD = register("minecraft:nether.crystal_field", new BiomeCrystalForest("nether.crystal_field").setColor(0xAA0000).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG).setTopBlock(Blocks.COBBLE_NETHERRACK.id()).setFillerBlock(Blocks.COBBLE_NETHERRACK.id()));
     public static final Biome NETHER_CRYSTAL_FOREST = register("minecraft:nether.crystal_forest", new BiomeCrystalForest("nether.crystal_forest").setColor(0xDD0000).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG).setTopBlock(Blocks.COBBLE_NETHERRACK.id()).setFillerBlock(Blocks.COBBLE_NETHERRACK.id()));
-    public static final Biome NETHER_ASH_PLAINS = register("minecraft:nether.ash_plains", new BiomeAshPlains("nether.ash_plains").setColor(0xDD0000).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG).setTopBlock(Blocks.SLATE.id()).setFillerBlock(Blocks.SLATE.id()));
-    public static final Biome NETHER_BONEYARD = register("minecraft:nether.boneyard", new BiomeBoneyard("nether.boneyard").setColor(0xDD0000).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG).setTopBlock(Blocks.SOULSAND.id()).setFillerBlock(Blocks.SOULSAND.id()));
+    public static final Biome NETHER_OLD_WORLD = register("minecraft:nether.old_world", new BiomeNether("nether.old_world").setColor(0x636480).setSurfaceSnow().setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG).setTopBlock(Blocks.COBBLE_NETHERRACK.id()).setFillerBlock(Blocks.COBBLE_NETHERRACK.id()));
+    public static final Biome NETHER_SHELF = register("minecraft:nether.shelf", new BiomeNether("nether.shelf").setColor(0x968a6f).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG).setTopBlock(Blocks.COBBLE_NETHERRACK.id()).setFillerBlock(Blocks.COBBLE_NETHERRACK.id()));
 
     public static final Biome OVERWORLD_LEGACY_RAINFOREST = register("minecraft:overworld.legacy.rainforest", new BiomeRainforestLegacy("overworld.legacy.rainforest").setColor(0xd9e023).setBlockedWeathers(Weathers.OVERWORLD_SNOW).setDefaults(0.985f,  0.95f, 0.5f));
     public static final Biome OVERWORLD_LEGACY_SWAMPLAND = register("minecraft:overworld.legacy.swampland", new BiomeSwampLegacy("overworld.legacy.swampland").setColor(0x07f9b2).setDefaults(0.75f, 0.4f, 0.5f));
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderNether.java b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderNether.java
index 8d0508689..f2c6f85bc 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderNether.java
@@ -15,25 +15,26 @@ public final class BiomeProviderNether
     extends BiomeProvider
 {
     public static final Biome[] BIOMES_ORDER = {
-            Biomes.NETHER_BONEYARD,
-            Biomes.NETHER_ASH_PLAINS,
+            Biomes.NETHER_OLD_WORLD,
+            Biomes.NETHER_CRYSTAL_FIELD,
             Biomes.NETHER_CRYSTAL_FOREST,
+            Biomes.NETHER_SHELF,
+            Biomes.NETHER_CRAG,
             Biomes.NETHER_SULFUR_POOLS,
-            Biomes.NETHER_NETHER,
-            Biomes.NETHER_VOLCANIC_ISLANDS
+            Biomes.NETHER_VOLCANIC_ISLANDS,
     };
 
     private final FractalNoise2D<?> temperatureNoise;
     private final FractalNoise2D<?> fuzzinessNoise;
 
-    private double temperatureXScale = 0.0125;
-    private double temperatureZScale = 0.0125;
-    private double temperatureLacunarity = 0.25;
-    private double temperatureFuzzPercentage = 0.01;
+    private double temperatureXScale = 0.025;
+    private double temperatureZScale = 0.025;
+    private double temperatureLacunarity = 0.3;
+    private double temperatureFuzzPercentage = 0.02;
 
-    private double fuzzinessXScale = 0.25;
-    private double fuzzinessZScale = 0.25;
-    private double fuzzinessLacunarity = 1.0;
+    private double fuzzinessXScale = 0.2;
+    private double fuzzinessZScale = 0.2;
+    private double fuzzinessLacunarity = 0.25;
 
     public BiomeProviderNether(final @NotNull World world)
     {
@@ -94,15 +95,17 @@ public final class BiomeProviderNether
 
         double fuzzPctg = temperatureFuzzPercentage;
         double valPctg = 1.0 - fuzzPctg;
-        double temperature = (tnResult[0] * 0.15 + 0.7) * valPctg + fuzziness * fuzzPctg;
+        double temperature = (tnResult[0]) * valPctg + fuzziness * fuzzPctg;
+
+        temperature = 1.0 - (1.0 - temperature) * (1.0 - temperature);
 
         if (temperature < 0.0)
         {
-            temperature = 0.0;
+            temperature = -temperature;
         }
         if (temperature > 1.0)
         {
-            temperature = 1.0;
+            temperature = -temperature;
         }
 
         return temperature;
@@ -126,7 +129,7 @@ public final class BiomeProviderNether
 
                 double fuzzPctg = temperatureFuzzPercentage;
                 double valPctg = 1.0 - fuzzPctg;
-                double temperature = (tnResult[dx * zSize + dz] * 0.15 + 0.7) * valPctg + fuzziness * fuzzPctg;
+                double temperature = (tnResult[dx * zSize + dz] * 0.1 + 0.5) * valPctg + fuzziness * fuzzPctg;
 
                 if (temperature < 0.0)
                 {
@@ -184,7 +187,7 @@ public final class BiomeProviderNether
             }
         }
 
-        return Biomes.NETHER_NETHER;
+        return Biomes.NETHER_CRAG;
     }
 
     public static Biome[] allBiomes() {
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/LavaFloeLargeFeature.java b/game/core/src/main/java/net/minecraft/core/world/generate/LavaFloeLargeFeature.java
new file mode 100644
index 000000000..13b0dcf71
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/LavaFloeLargeFeature.java
@@ -0,0 +1,102 @@
+package net.minecraft.core.world.generate;
+
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.biome.Biomes;
+import net.minecraft.core.world.chunk.Chunk;
+import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
+import net.minecraft.core.world.noise.FractalNoise2D;
+import net.minecraft.core.world.noise.ImprovedPerlinNoise;
+import net.minecraft.core.world.noise.Noise2D;
+import net.minecraft.core.world.noise.WorleyNoise;
+import net.minecraft.core.world.noise.operator.Normalize2D;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.type.WorldType;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Random;
+
+public class LavaFloeLargeFeature
+    extends LargeFeature {
+    private @Nullable WorleyNoise chunkNoise = null;
+    private @Nullable Noise2D gapNoise = null;
+    private @Nullable Noise2D heightNoise = null;
+    private @Nullable Noise2D scaleNoise = null;
+    private @Nullable World lastWorld = null;
+
+    @Override
+    protected void doGeneration(
+        @NotNull final World world,
+        @NotNull final Random random,
+        final int chunkX, final int chunkZ,
+        final int baseChunkX, final int baseChunkZ,
+        @NotNull final ChunkGeneratorResult result
+    ) {
+        if (this.chunkNoise == null || this.gapNoise == null || this.heightNoise == null || this.scaleNoise == null || this.lastWorld != world) {
+            this.chunkNoise = new WorleyNoise(new Random(world.getRandomSeed()));
+            this.gapNoise = new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 4));
+            this.heightNoise = new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 4));
+            this.scaleNoise = new Normalize2D<>(new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 2)));
+            this.lastWorld = world;
+        }
+
+        final @NotNull WorldType worldType = world.getWorldType();
+        final int oceanY = worldType.getMinY(world) + worldType.getOceanY();
+
+        final @NotNull TilePos tilePos = new TilePos();
+        final @NotNull WorleyNoise.Result worleyResult = new WorleyNoise.Result();
+
+        for (int x = 0; x < Chunk.CHUNK_SIZE_X; x++) {
+            for (int z = 0; z < Chunk.CHUNK_SIZE_Z; z++) {
+                tilePos.set(Chunk.CHUNK_SIZE_X * baseChunkX + x, oceanY, Chunk.CHUNK_SIZE_Z * baseChunkZ + z);
+                final @NotNull Biome biome = world.getBlockBiome(tilePos);
+                if (biome == Biomes.NETHER_VOLCANIC_ISLANDS) {
+                    final float worleyScaleScale = 50.0f;
+                    final float worleyScale = 1.0f + (0.0625f - (float) (this.scaleNoise.getValue((baseChunkX * Chunk.CHUNK_SIZE_X + x) / worleyScaleScale, (baseChunkZ * Chunk.CHUNK_SIZE_Z + z) / worleyScaleScale))) * 0.125f;
+                    this.chunkNoise.getValue(
+                            (baseChunkX + ((float) x / (float) Chunk.CHUNK_SIZE_X)) * worleyScale,
+                            (baseChunkZ + ((float) z / (float) Chunk.CHUNK_SIZE_Z)) * worleyScale,
+                            worleyResult
+                    );
+                    final float lineScale = 5.0f;
+                    final float lineWidth = (float) (this.gapNoise.getValue((baseChunkX * Chunk.CHUNK_SIZE_X + x) / lineScale, (baseChunkZ * Chunk.CHUNK_SIZE_Z + z) / lineScale) / 2.0 + 0.5);
+
+                    int heightMod = worleyResult.getRandom().nextInt(3) + 1;
+
+                    final float height = (float) (this.heightNoise.getValue((baseChunkX * Chunk.CHUNK_SIZE_X + x) / 5F, (baseChunkZ * Chunk.CHUNK_SIZE_Z + z) / 5F) / 2.0 + 0.5) * heightMod;
+
+                    if (MathHelper.unsignedMod(worleyResult.index, 15) != 0) {
+                        if (worleyResult.distance > 0.9f + lineWidth * 0.01f) {
+                            continue;
+                        }
+                        for (int y = oceanY - 3; y < oceanY + (height - 2); y++) {
+                            if(random.nextInt(20) == 0) {
+                                this.trySetBlock(result, x, y, z, Blocks.PUMICE_WET.id());
+                            } else {
+                                this.trySetBlock(result, x, y, z, Blocks.COBBLE_NETHERRACK.id());
+                            }
+                        }
+                        for (int y = oceanY + (int) (height - 2); y < oceanY + (height + 1); y++) {
+                            this.trySetBlock(result, x, y, z, Blocks.BRIMSAND.id());
+                        }
+                    }
+                }
+            }
+        }
+    }
+
+    private void trySetBlock(final @NotNull ChunkGeneratorResult result, final int x, final int y, final int z, final int id) {
+        final int current = result.getBlock(x, y, z);
+        if (current == Blocks.FLUID_LAVA_STILL.id() || current == 0) {
+            result.setBlock(x, y, z, id);
+        }
+    }
+
+    @Override
+    public int getRadiusChunk() {
+        return 0;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/ShelfLargeFeature.java b/game/core/src/main/java/net/minecraft/core/world/generate/ShelfLargeFeature.java
new file mode 100644
index 000000000..7051d3134
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/ShelfLargeFeature.java
@@ -0,0 +1,84 @@
+package net.minecraft.core.world.generate;
+
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.biome.Biomes;
+import net.minecraft.core.world.chunk.Chunk;
+import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
+import net.minecraft.core.world.noise.FractalNoise2D;
+import net.minecraft.core.world.noise.ImprovedPerlinNoise;
+import net.minecraft.core.world.noise.Noise2D;
+import net.minecraft.core.world.noise.WorleyNoise;
+import net.minecraft.core.world.noise.operator.Normalize2D;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.type.WorldType;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Random;
+
+public class ShelfLargeFeature
+    extends LargeFeature {
+    private @Nullable WorleyNoise chunkNoise = null;
+    private @Nullable Noise2D gapNoise = null;
+    private @Nullable Noise2D scaleNoise = null;
+    private @Nullable World lastWorld = null;
+
+    @Override
+    protected void doGeneration(
+        @NotNull final World world,
+        @NotNull final Random random,
+        final int chunkX, final int chunkZ,
+        final int baseChunkX, final int baseChunkZ,
+        @NotNull final ChunkGeneratorResult result
+    ) {
+        if (this.chunkNoise == null || this.gapNoise == null || this.scaleNoise == null || this.lastWorld != world) {
+            this.chunkNoise = new WorleyNoise(new Random(world.getRandomSeed()));
+            this.gapNoise = new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 4));
+            this.scaleNoise = new Normalize2D<>(new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 2)));
+            this.lastWorld = world;
+        }
+
+        final @NotNull WorldType worldType = world.getWorldType();
+        final int oceanY = worldType.getMinY(world) + worldType.getOceanY();
+
+        final @NotNull TilePos tilePos = new TilePos();
+        final @NotNull WorleyNoise.Result worleyResult = new WorleyNoise.Result();
+
+        for (int x = 0; x < Chunk.CHUNK_SIZE_X; x++) {
+            for (int z = 0; z < Chunk.CHUNK_SIZE_Z; z++) {
+                tilePos.set(Chunk.CHUNK_SIZE_X * baseChunkX + x, oceanY, Chunk.CHUNK_SIZE_Z * baseChunkZ + z);
+                final @NotNull Biome biome = world.getBlockBiome(tilePos);
+                if (biome == Biomes.NETHER_SHELF) {
+                    final float worleyScaleScale = 50.0f;
+                    final float worleyScale = 1.0f + (0.0625f - (float) (this.scaleNoise.getValue((baseChunkX * Chunk.CHUNK_SIZE_X + x) / worleyScaleScale, (baseChunkZ * Chunk.CHUNK_SIZE_Z + z) / worleyScaleScale))) * 0.125f;
+                    this.chunkNoise.getValue(
+                        (baseChunkX + ((float) x / (float) Chunk.CHUNK_SIZE_X)) * worleyScale,
+                        (baseChunkZ + ((float) z / (float) Chunk.CHUNK_SIZE_Z)) * worleyScale,
+                        worleyResult
+                    );
+
+                    int heightMod = worleyResult.getRandom().nextInt(5) + 1;
+
+                    for (int y = oceanY - 20; y < oceanY + heightMod; y++) {
+                        this.trySetBlock(result, x, y, z, Blocks.BRIMSAND.id());
+                    }
+                }
+            }
+        }
+    }
+
+    private void trySetBlock(final @NotNull ChunkGeneratorResult result, final int x, final int y, final int z, final int id) {
+        final int current = result.getBlock(x, y, z);
+        if (current == Blocks.FLUID_WATER_STILL.id() || current == 0) {
+            result.setBlock(x, y, z, id);
+        }
+    }
+
+    @Override
+    public int getRadiusChunk() {
+        return 0;
+    }
+}
